# This script converts phones to articulatory features 
# When a phone label in the tier 2 is clicked, corresponding features are automatically inserted
# Heejin Kim 2-1-2010

sel$ = selected$("TextGrid")

editor TextGrid 'sel$'
cursor = Get cursor
endeditor

textgrid = selected("TextGrid 'sel$'")
select 'textgrid'

interval_index = Get interval at time... 2 'cursor'

phone$ = Get label of interval... 2 'interval_index'
startP = Get start point... 2 'interval_index'
endP= Get end point... 2 'interval_index'

# insert boundaries in articulatory feature tiers
for j from 3 to 10
  indexB = Get interval at time... j 'startP'
  startNew = Get start point... j 'indexB'
  endNew = Get end point... j 'indexB'
     if (startNew < startP) & (endNew > endP)
       Insert boundary... 'j' 'startP'
       Insert boundary... 'j' 'endP'
     elsif (startNew < startP) & (endNew <= endP)
       Insert boundary... 'j' 'startP'
     elsif (startNew = startP) &  (endNew > endP)
       Insert boundary... 'j' 'endP'
  endif
endfor

# create array
phn1$ = "aa"
plf1$ = "NONE"
dgf1$ = "VOW"
pls1$ = "NONE"
dgs1$ = "VOW"
nas1$ = "-"
glo1$ = "VOI"
rd1$ = "-"
vow1$ = "aa"

phn2$ = "ae"
plf2$ = "NONE"
dgf2$ = "VOW"
pls2$ = "NONE"
dgs2$ = "VOW"
nas2$ = "-"
glo2$ = "VOI"
rd2$ = "-"
vow2$ = "ae"

phn3$ = "ah"
plf3$ = "NONE"
dgf3$ = "VOW"
pls3$ = "NONE"
dgs3$ = "VOW"
nas3$ = "-"
glo3$ = "VOI"
rd3$ = "-"
vow3$ = "ah"

phn4$ = "ao"
plf4$ = "NONE"
dgf4$ = "VOW"
pls4$ = "NONE"
dgs4$ = "VOW"
nas4$ = "-"
glo4$ = "VOI"
rd4$ = "+"
vow4$ = "ao"

phn5$ = "aw1"
plf5$ = "NONE"
dgf5$ = "VOW"
pls5$ = "NONE"
dgs5$ = "VOW"
nas5$ = "-"
glo5$ = "VOI"
rd5$ = "-"
vow5$ = "aw1"

phn6$ = "aw2"
plf6$ = "NONE"
dgf6$ = "VOW"
pls6$ = "NONE"
dgs6$ = "VOW"
nas6$ = "-"
glo6$ = "VOI"
rd6$ = "+"
vow6$ = "aw2"

phn7$ = "ax"
plf7$ = "NONE"
dgf7$ = "VOW"
pls7$ = "NONE"
dgs7$ = "VOW"
nas7$ = "-"
glo7$ = "VOI"
rd7$ = "-"
vow7$ = "ax"

phn8$ = "axr"
plf8$ = "RHO"
dgf8$ = "APP"
pls8$ = "NONE"
dgs8$ = "VOW"
nas8$ = "-"
glo8$ = "VOI"
rd8$ = "*"
vow8$ = "axr"

phn9$ = "ay1"
plf9$ = "NONE"
dgf9$ = "VOW"
pls9$ = "NONE"
dgs9$ = "VOW"
nas9$ = "-"
glo9$ = "VOI"
rd9$ = "-"
vow9$ = "ay1"

phn10$ = "ay2"
plf10$ = "NONE"
dgf10$ = "VOW"
pls10$ = "NONE"
dgs10$ = "VOW"
nas10$ = "-"
glo10$ = "VOI"
rd10$ = "-"
vow10$ = "ay2"

phn11$ = "b"
plf11$ = "LAB"
dgf11$ = "BUR"
pls11$ = "NONE"
dgs11$ = "VOW"
nas11$ = "-"
glo11$ = "VL"
rd11$ = "-"
vow11$ = "N/A"

phn12$ = "bcl"
plf12$ = "LAB"
dgf12$ = "CLO"
pls12$ = "NONE"
dgs12$ = "VOW"
nas12$ = "-"
glo12$ = "VOI"
rd12$ = "-"
vow12$ = "N/A"

phn13$ = "ch"
plf13$ = "P-A"
dgf13$ = "FRIC"
pls13$ = "NONE"
dgs13$ = "VOW"
nas13$ = "-"
glo13$ = "VL"
rd13$ = "*"
vow13$ = "N/A"

phn14$ = "d"
plf14$ = "ALV"
dgf14$ = "BUR"
pls14$ = "NONE"
dgs14$ = "VOW"
nas14$ = "-"
glo14$ = "VL"
rd14$ = "-"
vow14$ = "N/A"

phn15$ = "dcl"
plf15$ = "ALV"
dgf15$ = "CLO"
pls15$ = "NONE"
dgs15$ = "VOW"
nas15$ = "-"
glo15$ = "VOI"
rd15$ = "-"
vow15$ = "N/A"

phn16$ = "dh"
plf16$ = "DEN"
dgf16$ = "FRIC"
pls16$ = "NONE"
dgs16$ = "VOW"
nas16$ = "-"
glo16$ = "VOI"
rd16$ = "-"
vow16$ = "N/A"

phn17$ = "dx"
plf17$ = "ALV"
dgf17$ = "FLAP"
pls17$ = "NONE"
dgs17$ = "VOW"
nas17$ = "-"
glo17$ = "VOI"
rd17$ = "-"
vow17$ = "N/A"

phn18$ = "eh"
plf18$ = "NONE"
dgf18$ = "VOW"
pls18$ = "NONE"
dgs18$ = "VOW"
nas18$ = "-"
glo18$ = "VOI"
rd18$ = "-"
vow18$ = "eh"

phn19$ = "el"
plf19$ = "LAT"
dgf19$ = "CLO"
pls19$ = "NONE"
dgs19$ = "VOW"
nas19$ = "-"
glo19$ = "VOI"
rd19$ = "-"
vow19$ = "el"

phn20$ = "em"
plf20$ = "LAB"
dgf20$ = "CLO"
pls20$ = "NONE"
dgs20$ = "VOW"
nas20$ = "+"
glo20$ = "VOI"
rd20$ = "-"
vow20$ = "em"

phn21$ = "en"
plf21$ = "ALV"
dgf21$ = "CLO"
pls21$ = "NONE"
dgs21$ = "VOW"
nas21$ = "+"
glo21$ = "VOI"
rd21$ = "-"
vow21$ = "en"

phn22$ = "er"
plf22$ = "RHO"
dgf22$ = "APP"
pls22$ = "NONE"
dgs22$ = "VOW"
nas22$ = "-"
glo22$ = "VOI"
rd22$ = "*"
vow22$ = "er"

phn23$ = "ey1"
plf23$ = "NONE"
dgf23$ = "VOW"
pls23$ = "NONE"
dgs23$ = "VOW"
nas23$ = "-"
glo23$ = "VOI"
rd23$ = "-"
vow23$ = "ey1"

phn24$ = "ey2"
plf24$ = "NONE"
dgf24$ = "VOW"
pls24$ = "NONE"
dgs24$ = "VOW"
nas24$ = "-"
glo24$ = "VOI"
rd24$ = "-"
vow24$ = "ey2"

phn25$ = "f"
plf25$ = "L-D"
dgf25$ = "FRIC"
pls25$ = "NONE"
dgs25$ = "VOW"
nas25$ = "-"
glo25$ = "VL"
rd25$ = "-"
vow25$ = "N/A"

phn26$ = "g"
plf26$ = "VEL"
dgf26$ = "BUR"
pls26$ = "NONE"
dgs26$ = "VOW"
nas26$ = "-"
glo26$ = "VL"
rd26$ = "-"
vow26$ = "N/A"

phn27$ = "gcl"
plf27$ = "VEL"
dgf27$ = "CLO"
pls27$ = "NONE"
dgs27$ = "VOW"
nas27$ = "-"
glo27$ = "VOI"
rd27$ = "-"
vow27$ = "N/A"

phn28$ = "hh"
plf28$ = "NONE"
dgf28$ = "VOW"
pls28$ = "NONE"
dgs28$ = "VOW"
nas28$ = "-"
glo28$ = "ASP"
rd28$ = "*"
vow28$ = "*"

phn29$ = "ih"
plf29$ = "NONE"
dgf29$ = "VOW"
pls29$ = "NONE"
dgs29$ = "VOW"
nas29$ = "-"
glo29$ = "VOI"
rd29$ = "-"
vow29$ = "ih"

phn30$ = "ix"
plf30$ = "NONE"
dgf30$ = "VOW"
pls30$ = "NONE"
dgs30$ = "VOW"
nas30$ = "-"
glo30$ = "VOI"
rd30$ = "-"
vow30$ = "ix"

phn31$ = "iy"
plf31$ = "NONE"
dgf31$ = "VOW"
pls31$ = "NONE"
dgs31$ = "VOW"
nas31$ = "-"
glo31$ = "VOI"
rd31$ = "-"
vow31$ = "iy"

phn32$ = "jh"
plf32$ = "P-A"
dgf32$ = "FRIC"
pls32$ = "NONE"
dgs32$ = "VOW"
nas32$ = "-"
glo32$ = "VOI"
rd32$ = "*"
vow32$ = "N/A"

phn33$ = "k"
plf33$ = "VEL"
dgf33$ = "BUR"
pls33$ = "NONE"
dgs33$ = "VOW"
nas33$ = "-"
glo33$ = "VL"
rd33$ = "-"
vow33$ = "N/A"

phn34$ = "kcl"
plf34$ = "VEL"
dgf34$ = "CLO"
pls34$ = "NONE"
dgs34$ = "VOW"
nas34$ = "-"
glo34$ = "VL"
rd34$ = "-"
vow34$ = "N/A"

phn35$ = "l"
plf35$ = "LAT"
dgf35$ = "CLO"
pls35$ = "NONE"
dgs35$ = "VOW"
nas35$ = "-"
glo35$ = "VOI"
rd35$ = "-"
vow35$ = "N/A"

phn36$ = "m"
plf36$ = "LAB"
dgf36$ = "CLO"
pls36$ = "NONE"
dgs36$ = "VOW"
nas36$ = "+"
glo36$ = "VOI"
rd36$ = "-"
vow36$ = "N/A"

phn37$ = "n"
plf37$ = "ALV"
dgf37$ = "CLO"
pls37$ = "NONE"
dgs37$ = "VOW"
nas37$ = "+"
glo37$ = "VOI"
rd37$ = "-"
vow37$ = "N/A"

phn38$ = "ng"
plf38$ = "VEL"
dgf38$ = "CLO"
pls38$ = "NONE"
dgs38$ = "VOW"
nas38$ = "+"
glo38$ = "VOI"
rd38$ = "-"
vow38$ = "N/A"

phn39$ = "nx"
plf39$ = "ALV"
dgf39$ = "FLAP"
pls39$ = "NONE"
dgs39$ = "VOW"
nas39$ = "+"
glo39$ = "VOI"
rd39$ = "-"
vow39$ = "N/A"

phn40$ = "ow1"
plf40$ = "NONE"
dgf40$ = "VOW"
pls40$ = "NONE"
dgs40$ = "VOW"
nas40$ = "-"
glo40$ = "VOI"
rd40$ = "+"
vow40$ = "ow1"

phn41$ = "ow2"
plf41$ = "NONE"
dgf41$ = "VOW"
pls41$ = "NONE"
dgs41$ = "VOW"
nas41$ = "-"
glo41$ = "VOI"
rd41$ = "+"
vow41$ = "ow2"

phn42$ = "oy1"
plf42$ = "NONE"
dgf42$ = "VOW"
pls42$ = "NONE"
dgs42$ = "VOW"
nas42$ = "-"
glo42$ = "VOI"
rd42$ = "+"
vow42$ = "oy1"

phn43$ = "oy2"
plf43$ = "NONE"
dgf43$ = "VOW"
pls43$ = "NONE"
dgs43$ = "VOW"
nas43$ = "-"
glo43$ = "VOI"
rd43$ = "-"
vow43$ = "oy2"

phn44$ = "p"
plf44$ = "LAB"
dgf44$ = "BUR"
pls44$ = "NONE"
dgs44$ = "VOW"
nas44$ = "-"
glo44$ = "VL"
rd44$ = "-"
vow44$ = "N/A"

phn45$ = "pcl"
plf45$ = "LAB"
dgf45$ = "CLO"
pls45$ = "NONE"
dgs45$ = "VOW"
nas45$ = "-"
glo45$ = "VL"
rd45$ = "-"
vow45$ = "N/A"

phn46$ = "q"
plf46$ = "GLO"
dgf46$ = "CLO"
pls46$ = "NONE"
dgs46$ = "VOW"
nas46$ = "-"
glo46$ = "STOP/IRR"
rd46$ = "-"
vow46$ = "*"

phn47$ = "r"
plf47$ = "RHO"
dgf47$ = "APP"
pls47$ = "NONE"
dgs47$ = "VOW"
nas47$ = "-"
glo47$ = "VOI"
rd47$ = "*"
vow47$ = "N/A"

phn48$ = "s"
plf48$ = "ALV"
dgf48$ = "FRIC"
pls48$ = "NONE"
dgs48$ = "VOW"
nas48$ = "-"
glo48$ = "VL"
rd48$ = "-"
vow48$ = "N/A"

phn49$ = "sh"
plf49$ = "P-A"
dgf49$ = "FRIC"
pls49$ = "NONE"
dgs49$ = "VOW"
nas49$ = "-"
glo49$ = "VL"
rd49$ = "*"
vow49$ = "N/A"

phn50$ = "sil"
plf50$ = "SIL"
dgf50$ = "SIL"
pls50$ = "SIL"
dgs50$ = "SIL"
nas50$ = "-"
glo50$ = "VL"
rd50$ = "-"
vow50$ = "N/A"

phn51$ = "t"
plf51$ = "ALV"
dgf51$ = "BUR"
pls51$ = "NONE"
dgs51$ = "VOW"
nas51$ = "-"
glo51$ = "VL"
rd51$ = "-"
vow51$ = "N/A"

phn52$ = "tcl"
plf52$ = "ALV"
dgf52$ = "CLO"
pls52$ = "NONE"
dgs52$ = "VOW"
nas52$ = "-"
glo52$ = "VL"
rd52$ = "-"
vow52$ = "N/A"

phn53$ = "th"
plf53$ = "DEN"
dgf53$ = "FRIC"
pls53$ = "NONE"
dgs53$ = "VOW"
nas53$ = "-"
glo53$ = "VL"
rd53$ = "-"
vow53$ = "N/A"

phn54$ = "uh"
plf54$ = "NONE"
dgf54$ = "VOW"
pls54$ = "NONE"
dgs54$ = "VOW"
nas54$ = "-"
glo54$ = "VOI"
rd54$ = "+"
vow54$ = "uh"

phn55$ = "uw"
plf55$ = "NONE"
dgf55$ = "VOW"
pls55$ = "NONE"
dgs55$ = "VOW"
nas55$ = "-"
glo55$ = "VOI"
rd55$ = "+"
vow55$ = "uw"

phn56$ = "ux"
plf56$ = "NONE"
dgf56$ = "VOW"
pls56$ = "NONE"
dgs56$ = "VOW"
nas56$ = "-"
glo56$ = "VOI"
rd56$ = "+"
vow56$ = "ux"

phn57$ = "v"
plf57$ = "L-D"
dgf57$ = "FRIC"
pls57$ = "NONE"
dgs57$ = "VOW"
nas57$ = "-"
glo57$ = "VOI"
rd57$ = "-"
vow57$ = "N/A"

phn58$ = "w"
plf58$ = "LAB"
dgf58$ = "APP"
pls58$ = "VEL"
dgs58$ = "APP"
nas58$ = "-"
glo58$ = "VOI"
rd58$ = "+"
vow58$ = "N/A"

phn59$ = "y"
plf59$ = "P-A"
dgf59$ = "APP"
pls59$ = "NONE"
dgs59$ = "VOW"
nas59$ = "-"
glo59$ = "VOI"
rd59$ = "-"
vow59$ = "N/A"

phn60$ = "z"
plf60$ = "ALV"
dgf60$ = "FRIC"
pls60$ = "NONE"
dgs60$ = "VOW"
nas60$ = "-"
glo60$ = "VOI"
rd60$ = "-"
vow60$ = "N/A"

phn61$ = "zh"
plf61$ = "P-A"
dgf61$ = "FRIC"
pls61$ = "NONE"
dgs61$ = "VOW"
nas61$ = "-"
glo61$ = "VOI"
rd61$ = "*"
vow61$ = "N/A"

phn62$ = "xxx"
plf62$ = "xxx"
dgf62$ = "xxx"
pls62$ = "xxx"
dgs62$ = "xxx"
nas62$ = "xxx"
glo62$ = "xxx"
rd62$ = "xxx"
vow62$ = "xxx"

phn63$ = ""

# find out the matching array index
i = 0
repeat
   i = i + 1
until (i = 63) or (phone$ = phn'i'$)

if (i = 63)
  # not found
  exit "Invalid label"
endif

# Label gesture intervals using 'procedure'
tier = 3
arrayName$ = "plf"
call labeling

tier = 4
arrayName$ = "dgf"
call labeling

tier = 5
arrayName$ = "pls"
call labeling

tier = 6
arrayName$ = "dgs"
call labeling

tier = 7
arrayName$ = "nas"
call labeling

tier = 8
arrayName$ = "glo"
call labeling

tier = 9
arrayName$ = "rd"
call labeling

tier = 10
arrayName$ = "vow"
call labeling

procedure labeling
  select 'textgrid'
  intN = Get interval at time... 'tier' startP
  label$ = 'arrayName$''i'$
  Set interval text... 'tier' intN 'label$'
endproc

